From 56cff3a43d52bf58a4dbb7fa376949e95fc1df5a Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jan 31 2017 17:14:37 +0000
Subject: [PATCH 680/1001] Use request.get_json() and .get_data() where approriate


---

diff --git a/hubs/app.py b/hubs/app.py
index ca3bd26..89b5271 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -21,7 +21,7 @@ import hubs.stream
 
 import datanommer.models
 
-from hubs.utils import username2avatar, to_str
+from hubs.utils import username2avatar
 
 app = flask.Flask(__name__)
 
@@ -547,7 +547,7 @@ def notifications(user):
         return flask.jsonify(notifications)
 
     if flask.request.method == 'POST':
-        data = json.loads(to_str(flask.request.data))
+        data = flask.request.get_json()
         user = hubs.models.User.by_username(session, user)
         if not user:
             return flask.abort(400)
diff --git a/hubs/tests/test_api/test_notifications.py b/hubs/tests/test_api/test_notifications.py
index 360fa4c..5b8ad9e 100644
--- a/hubs/tests/test_api/test_notifications.py
+++ b/hubs/tests/test_api/test_notifications.py
@@ -6,7 +6,6 @@ from six.moves.urllib.parse import urlparse
 import hubs.tests
 import hubs.models
 from hubs.app import app
-from hubs.utils import to_str
 
 
 class TestGetNotifications(hubs.tests.APPTest):
@@ -18,7 +17,7 @@ class TestGetNotifications(hubs.tests.APPTest):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.get('/{}/notifications/'.format(name))
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(to_str(resp.data))
+        data = json.loads(resp.get_data(as_text=True))
         self.assertEqual(data, [])
 
     def test_get_notifications_valid_name(self):
@@ -27,7 +26,7 @@ class TestGetNotifications(hubs.tests.APPTest):
                 self.user.username))
 
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(to_str(resp.data))
+        data = json.loads(resp.get_data(as_text=True))
         self.assertEqual(len(data), 1)
 
         for saved in data:
@@ -53,24 +52,27 @@ class TestPostNotifications(hubs.tests.APPTest):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
                 '/{}/notifications/'.format('notarealfasuser'),
-                data=json.dumps(self.valid_payload))
+                data=json.dumps(self.valid_payload),
+                content_type='application/json')
         self.assertEqual(resp.status_code, 400)
 
     def test_post_notification_invalid_payload(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
                 '/{}/notifications/'.format(self.user.username),
-                data=json.dumps(self.invalid_payload))
+                data=json.dumps(self.invalid_payload),
+                content_type='application/json')
         self.assertEqual(resp.status_code, 400)
 
     def test_post_notification_valid_payload(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
                 '/{}/notifications/'.format(self.user.username),
-                data=json.dumps(self.valid_payload))
+                data=json.dumps(self.valid_payload),
+                content_type='application/json')
 
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(to_str(resp.data))
+        data = json.loads(resp.get_data(as_text=True))
         self.assertTrue(isinstance(data, dict))
 
         notification = data['notification']
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index edfc6a6..3c24905 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -13,7 +13,6 @@ from werkzeug.datastructures import ImmutableMultiDict
 import hubs
 from hubs import tests
 from hubs.app import app
-from hubs.utils import to_str
 
 import hubs.models
 
@@ -35,17 +34,19 @@ class HubsAPITest(hubs.tests.APPTest):
             # its trying to redirect to login id.fedoraproject.org/openid
             # assert the status code of the response
             self.assertEqual(result.status_code, 200)
-            self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in to_str(result.data))
+            self.assertNotIn(
+                'Not logged in.  Click to <a href="/login">login</a>',
+                result.get_data(as_text=True))
 
     def test_hub_logged_out(self):
         with tests.auth_set(app, None):  # check_auth doesn't load in unittest
             result = self.app.get('/ralph', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             match_expected = r'<h5[^>]*>Ralph</h5>'
-            self.assertRegexpMatches(to_str(result.data), match_expected)
+            self.assertRegexpMatches(
+                result.get_data(as_text=True), match_expected)
             str_expected = 'Not logged in.'
-            self.assertTrue(str_expected in to_str(result.data))
+            self.assertIn(str_expected, result.get_data(as_text=True))
 
     def test_groups_logged_out(self):
         result = self.app.get('/groups', follow_redirects=False)
@@ -60,16 +61,17 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/groups', follow_redirects=True)
             # assert the status code of the response
             self.assertEqual(result.status_code, 200)
-            self.assertTrue("ZOMG -  is the Hub Of The Month!"
-                            in to_str(result.data))
+            self.assertIn("ZOMG -  is the Hub Of The Month!",
+                          result.get_data(as_text=True))
 
     def test_hub_logged_in(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             result = self.app.get('/ralph', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in to_str(result.data))
+            self.assertNotIn(
+                'Not logged in.  Click to <a href="/login">login</a>',
+                result.get_data(as_text=True))
 
     def test_hub_json(self):
         result = self.app.get('/ralph/json', follow_redirects=True)
@@ -87,7 +89,7 @@ class HubsAPITest(hubs.tests.APPTest):
             "summary": "Ralph",
             "widgets": [34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 56]
         }
-        self.assertDictEqual(data, json.loads(to_str(result.data)))
+        self.assertDictEqual(data, json.loads(result.get_data(as_text=True)))
 
     @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_get_logged_out(self):
@@ -136,10 +138,12 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.post('/ralph/edit', data={},
                                    follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in to_str(result.data))
-            self.assertTrue('<a href="#" class="dropdown-item">Full Name: '
-                            'fullname: ralph</a>' in to_str(result.data))
+            self.assertNotIn(
+                'Not logged in.  Click to <a href="/login">login</a>',
+                result.get_data(as_text=True))
+            self.assertIn(
+                '<a href="#" class="dropdown-item">Full Name: '
+                'fullname: ralph</a>', result.get_data(as_text=True))
 
     def test_hub_edit_post_logged_in_owner_valid_data(self):
         user = tests.FakeAuthorization('ralph')
@@ -160,7 +164,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.post('/ralph/edit', data=data,
                                    follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertEqual(to_str(result.data), 'ok')
+            self.assertEqual(result.get_data(as_text=True), 'ok')
 
     def test_hub_edit_post_logged_in_owner_invalid_data_1(self):
         user = tests.FakeAuthorization('ralph')
@@ -215,30 +219,30 @@ class HubsAPITest(hubs.tests.APPTest):
         result = self.app.get('/ralph/add', follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid position provided'
-        self.assertTrue(expected_str in to_str(result.data))
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_get_with_args(self):
         result = self.app.get('/ralph/add?position=right',
                               follow_redirects=True)
         self.assertEqual(result.status_code, 200)
         expected_str = 'Adding widget to hub: ralph'
-        self.assertTrue(expected_str in to_str(result.data))
+        self.assertIn(expected_str, result.get_data(as_text=True))
         expected_str = "url: 'add/' + $('#widget').val() + '?position=right',"
-        self.assertTrue(expected_str in to_str(result.data))
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_no_widget_name(self):
         data = {}
         result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid request sent'
-        self.assertTrue(expected_str in to_str(result.data))
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_invalid_widget_name(self):
         data = {'widget_name': 'invalid_widget_name'}
         result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 404)
         expected_str = 'Unknown widget called'
-        self.assertTrue(expected_str in to_str(result.data))
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_valid_widget_name_no_args(self):
         user = tests.FakeAuthorization('ralph')
@@ -248,9 +252,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=False)
             self.assertEqual(result.status_code, 200)
             expected_str = '<h6 class="dropdown-header">Account Information</h6>'
-            self.assertTrue(expected_str in to_str(result.data))
+            self.assertIn(expected_str, result.get_data(as_text=True))
             expected_str = '<a href="#" class="dropdown-item">Full Name: fullname: ralph</a>'
-            self.assertTrue(expected_str in to_str(result.data))
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_valid_widget_name_with_args(self):
         user = tests.FakeAuthorization('ralph')
@@ -260,9 +264,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=False)
             self.assertEqual(result.status_code, 200)
             expected_str = '<h6 class="dropdown-header">Account Information</h6>'
-            self.assertTrue(expected_str in to_str(result.data))
+            self.assertIn(expected_str, result.get_data(as_text=True))
             expected_str = '<a href="#" class="dropdown-item">Full Name: fullname: ralph</a>'
-            self.assertTrue(expected_str in to_str(result.data))
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_edit_widget_get_logged_in(self):
         user = tests.FakeAuthorization('ralph')
@@ -270,7 +274,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/ralph/37/edit', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             expected_str = '/ralph/37/edit'
-            self.assertTrue(expected_str in to_str(result.data))
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_widget_get_logged_out(self):
@@ -291,10 +295,14 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(json.loads(to_str(result.data)), {"count": 0})
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                {"count": 0})
 
             result = self.app.post(url)
-            self.assertEqual(json.loads(to_str(result.data)), {"count": 1})
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                {"count": 1})
 
             # accessing my hub shouldn't increment the count
             url = 'visit/ralph'
@@ -317,22 +325,22 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(to_str(result.data), '0')
+            self.assertEqual(result.get_data(as_text=True), '0')
 
             url = '/decause'
             result = self.app.get(url, follow_redirects=True)
 
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(to_str(result.data), '1')
+            self.assertEqual(result.get_data(as_text=True), '1')
 
     def test_hub_add_widget_valid_side(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             url = '/ralph/add/about?position=right'
             result = self.app.get(url)
-            self.assertTrue('Adding widget "about"to hub: ralph'
-                            in to_str(result.data))
+            self.assertIn('Adding widget "about"to hub: ralph',
+                          result.get_data(as_text=True))
 
     def test_hub_add_widget_invalid_side(self):
         user = tests.FakeAuthorization('ralph')
@@ -347,7 +355,7 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/ralph/37/delete'  # 37 is widget fedmsgstats for ralph
             result = self.app.post(url)
             self.assertEqual(result.status_code, 302)
-            self.assertTrue('/ralph/edit' in to_str(result.data))
+            self.assertIn('/ralph/edit', result.get_data(as_text=True))
 
     def test_source_name(self):
         with tests.auth_set(app, None):
@@ -356,7 +364,7 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertEqual(result.status_code, 302)
             expected_str = 'https://pagure.io/fedora-hubs/' \
                            'blob/develop/f/hubs/widgets/about.py'
-            self.assertIn(expected_str, to_str(result.data))
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_source_name_not_existent(self):
         with tests.auth_set(app, None):
@@ -420,7 +428,9 @@ class HubsAPITest(hubs.tests.APPTest):
             "total": 0,
             "username": "decause"
         }
-        self.assertEqual(json.loads(to_str(result.data)), expected)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_valid(self, mock_post):
@@ -436,7 +446,9 @@ class HubsAPITest(hubs.tests.APPTest):
                 "total": 1,
                 "username": "decause"
             }
-            self.assertEqual(json.loads(to_str(result.data)), expected)
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_myself_error(self, mock_post):
@@ -445,7 +457,9 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/plus_plus/ralph/update'
             result = self.app.post(url, data={'increment': True})
             self.assertEqual(result.status_code, 403)
-            self.assertEqual(to_str(result.data), 'You may not modify your own karma.')
+            self.assertEqual(
+                result.get_data(as_text=True),
+                'You may not modify your own karma.')
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_user_does_not_exist(self, mock_post):
@@ -454,7 +468,9 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/plus_plus/doesnotexist/update'
             result = self.app.post(url, data={'increment': True})
             self.assertEqual(result.status_code, 403)
-            self.assertEqual(to_str(result.data), 'User does not exist')
+            self.assertEqual(
+                result.get_data(as_text=True),
+                'User does not exist')
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_no_data_error(self, mock_post):
@@ -465,13 +481,13 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertEqual(result.status_code, 403)
             exp_str = "You must set 'decrement' or 'increment' " \
                       "with a boolean value in the body"
-            self.assertEqual(to_str(result.data), exp_str)
+            self.assertEqual(result.get_data(as_text=True), exp_str)
 
     def test_plus_plus_receiver_does_not_exist(self):
         url = '/plus_plus/doesnotexist/status'
         result = self.app.get(url)
         self.assertEqual(result.status_code, 403)
-        self.assertEqual(to_str(result.data), 'User does not exist')
+        self.assertEqual(result.get_data(as_text=True), 'User does not exist')
 
 
 
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index f894e4b..74e0c56 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -5,7 +5,6 @@ import json
 from nose.tools import assert_dict_equal
 
 import hubs.tests.test_widgets
-from hubs.utils import to_str
 
 
 class TestBadges(hubs.tests.test_widgets.WidgetTest):
@@ -15,7 +14,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(to_str(response.data))
+        data = json.loads(response.get_data(as_text=True))
         del data['data']['widget_url']
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/56/edit',
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index 2dd6458..8a88807 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -4,7 +4,6 @@ import json
 
 from mock import patch, MagicMock
 import hubs.tests.test_widgets
-from hubs.utils import to_str
 
 
 class TestBadges(hubs.tests.test_widgets.WidgetTest):
@@ -14,7 +13,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(to_str(response.data))
+        data = json.loads(response.get_data(as_text=True))
         self.assertEquals(data['plugin'], 'badges')
         self.assertIn('assertions', data['data'].keys())
 
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index bec2363..0d7e79d 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -3,7 +3,6 @@ from __future__ import unicode_literals
 import json
 
 import hubs.tests.test_widgets
-from hubs.utils import to_str
 
 
 class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
@@ -13,7 +12,7 @@ class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(to_str(response.data))
+        data = json.loads(response.get_data(as_text=True))
         del data['data']['widget_url']
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/37/edit',
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index 68f2598..9182b56 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -4,7 +4,6 @@ import json
 
 import hubs.tests.test_widgets
 import hubs.models
-from hubs.utils import to_str
 
 class TestLibrary(hubs.tests.test_widgets.WidgetTest):
     plugin = 'library'  # The name in hubs.widgets.registry
@@ -13,7 +12,7 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         self.assertEqual(response.status_code, 200)
-        data = json.loads(to_str(response.data))
+        data = json.loads(response.get_data(as_text=True))
         expected_dict = {
             "config": {
                 "urls": "ralph/"
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index d3b3f09..08ea046 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -3,7 +3,6 @@ from __future__ import unicode_literals
 import json
 
 import hubs.tests.test_widgets
-from hubs.utils import to_str
 
 
 class TestMeetings(hubs.tests.test_widgets.WidgetTest):
@@ -14,7 +13,7 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/json/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
-        data = json.loads(to_str(response.data))
+        data = json.loads(response.get_data(as_text=True))
         calendar_name = data['data']['calendar']
         self.assertIn(team, calendar_name)
 
@@ -23,6 +22,6 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
-        self.assertIn('i18n', to_str(response.data))
+        self.assertIn('i18n', response.get_data(as_text=True))
         self.assertIn('<strong>Request A New Meeting</strong>',
-                      to_str(response.data))
+                      response.get_data(as_text=True))
diff --git a/hubs/utils.py b/hubs/utils.py
index c858271..f1ecd92 100755
--- a/hubs/utils.py
+++ b/hubs/utils.py
@@ -81,14 +81,3 @@ def _github_results(url, auth):
                     part.split('; ')[0][1:-1],
                 ) for part in field.split(', ')
             ])
-
-
-def to_str(data):
-    """
-    A Python3-compatible way to return a string from a string or a UTF8-encoded
-    bytestring. Werkzeug responses are bytestrings on Python 3.
-    """
-    if isinstance(data, six.binary_type):
-        return data.decode('utf-8')
-    else:
-        return data

